'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LocaleProvider = require('./LocaleProvider');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class LocaleSwitch extends _react.Component {
  constructor(...args) {
    var _temp, _this;

    return _temp = _this = super(...args), this.handleChange = (() => {
      var _ref = (0, _asyncToGenerator3.default)(function* (locale) {
        const { onError, onChange, localeProvider } = _this.props;

        try {
          yield localeProvider.setLocale(locale);
          if (onChange) {
            onChange(locale);
          }
        } catch (e) {
          if (onError) {
            onError(e);
          }
        }
      });

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    })(), _temp;
  }

  render() {
    const { children, localeProvider } = this.props;

    return children({
      locale: localeProvider.getLocale(),
      changeLocale: this.handleChange
    });
  }
}

LocaleSwitch.defaultProps = {
  onError: undefined,
  onChange: undefined
};
exports.default = (0, _react.forwardRef)((props, ref) => _react2.default.createElement(
  _LocaleProvider.LocaleProviderContext.Consumer,
  null,
  ({ localeProvider }) => _react2.default.createElement(LocaleSwitch, (0, _extends3.default)({}, props, {
    localeProvider: localeProvider,
    ref: ref
  }))
));
//# sourceMappingURL=LocaleSwitch.js.map