'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NamespaceContext = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const NamespaceContext = exports.NamespaceContext = (0, _react.createContext)({});


class Namespace extends _react.Component {

  getPath() {
    const { path, compose, namespace } = this.props;
    if (!compose || !path) {
      return path;
    }

    if (namespace) {
      const parentPath = namespace.getPath();
      if (parentPath) {
        return `${parentPath}.${path}`;
      }
    }

    return path;
  }

  render() {
    const { children } = this.props;

    return _react2.default.createElement(
      NamespaceContext.Provider,
      { value: { namespace: this } },
      children
    );
  }
}

Namespace.defaultProps = {
  path: undefined,
  compose: undefined,
  namespace: undefined
};
exports.default = (0, _react.forwardRef)((props, ref) => _react2.default.createElement(
  NamespaceContext.Consumer,
  null,
  ({ namespace }) => _react2.default.createElement(Namespace, (0, _extends3.default)({}, props, {
    namespace: namespace,
    ref: ref
  }))
));
//# sourceMappingURL=Namespace.js.map