'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LocaleProvider = require('./LocaleProvider');

var _Namespace = require('./Namespace');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ProvideTranslate extends _react.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), _initialiseProps.call(this), _temp;
  }

  getPath(path) {
    const { namespace, ignoreNamespace } = this.props;
    if (!namespace || ignoreNamespace) {
      return path;
    }

    const parentPath = namespace.getPath();
    if (!parentPath) {
      return path;
    }

    return `${parentPath}.${path}`;
  }

  render() {
    const { children } = this.props;

    return children(this.translate);
  }
}
ProvideTranslate.defaultProps = {
  ignoreNamespace: false
};

var _initialiseProps = function () {
  this.translate = (path, ...args) => {
    const { localeProvider } = this.props;

    return localeProvider.get(this.getPath(path), ...args);
  };
};

exports.default = (0, _react.forwardRef)((props, ref) => _react2.default.createElement(
  _LocaleProvider.LocaleProviderContext.Consumer,
  null,
  ({ localeProvider }) => _react2.default.createElement(
    _Namespace.NamespaceContext.Consumer,
    null,
    ({ namespace }) => _react2.default.createElement(ProvideTranslate, (0, _extends3.default)({}, props, {
      localeProvider: localeProvider,
      namespace: namespace,
      ref: ref
    }))
  )
));
//# sourceMappingURL=ProvideTranslate.js.map