'use strict';

exports.__esModule = true;
exports.default = exports.LocaleProviderContext = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _translateMaker = require('translate-maker');

var _translateMaker2 = _interopRequireDefault(_translateMaker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LocaleProviderContext = exports.LocaleProviderContext = (0, _react.createContext)({});

var LocaleProvider = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(LocaleProvider, _Component);

  function LocaleProvider(props) {
    (0, _classCallCheck3.default)(this, LocaleProvider);

    var _this = (0, _possibleConstructorReturn3.default)(this, _Component.call(this, props));

    _this.t = function (path, attrs, defaultValue) {
      return _this.get(path, attrs, defaultValue);
    };

    _this.dataChanged = function () {
      _this.forceUpdate();
    };

    _this.localeChanged = function () {
      _this.forceUpdate();
    };

    var translate = props.translate,
        locale = props.locale,
        namespace = props.namespace,
        children = props.children,
        controlled = props.controlled,
        rest = (0, _objectWithoutProperties3.default)(props, ['translate', 'locale', 'namespace', 'children', 'controlled']);


    var instance = translate || new _translateMaker2.default(rest);

    _this.state = {
      translate: instance
    };

    if (locale) {
      instance.setLocale(locale, namespace);
    }
    return _this;
  }

  LocaleProvider.prototype.componentDidMount = function componentDidMount() {
    var translate = this.state.translate;


    translate.on('locale', this.localeChanged);
    translate.on('changed', this.dataChanged);
  };

  LocaleProvider.prototype.componentWillReceiveProps = function componentWillReceiveProps(newProps) {
    var _props = this.props,
        locale = _props.locale,
        namespace = _props.namespace;
    var translate = this.state.translate;


    if (newProps.controlled) {
      if (newProps.locale !== locale) {
        translate.setLocale(newProps.locale, newProps.namespace);
      } else if (newProps.locale && newProps.namespace !== namespace) {
        translate.setLocale(newProps.locale, newProps.namespace);
      }
    }
  };

  LocaleProvider.prototype.componentWillUnmount = function componentWillUnmount() {
    var translate = this.state.translate;


    translate.removeListener('locale', this.localeChanged);
    translate.removeListener('changed', this.dataChanged);
  };

  LocaleProvider.prototype.getLocale = function getLocale() {
    var translate = this.state.translate;

    return translate.getLocale();
  };

  LocaleProvider.prototype.setLocale = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(locale) {
      var controlled, translate;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              controlled = this.props.controlled;

              if (!controlled) {
                _context.next = 3;
                break;
              }

              throw new Error('LocaleProvider is set as controlled component. If you want to use setLocale please set controlled = false');

            case 3:
              translate = this.state.translate;
              _context.next = 6;
              return translate.setLocale(locale);

            case 6:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function setLocale(_x) {
      return _ref.apply(this, arguments);
    }

    return setLocale;
  }();

  LocaleProvider.prototype.get = function get(path, attrs, defaultValue) {
    var translate = this.state.translate;

    return translate.get(path, attrs, defaultValue);
  };

  LocaleProvider.prototype.set = function set(path, value) {
    var translate = this.state.translate;

    return translate.set(path, value);
  };

  LocaleProvider.prototype.render = function render() {
    var children = this.props.children;


    return _react2.default.createElement(
      LocaleProviderContext.Provider,
      { value: { localeProvider: this } },
      children
    );
  };

  return LocaleProvider;
}(_react.Component), _class.defaultProps = {
  controlled: true
  /*
  locale: undefined,
  namespace: undefined,
  locales: undefined,
  cache: undefined,
  data: undefined,
  adapter: undefined,
  dotNotation: undefined,
  mode: undefined,
  references: undefined,
  variables: undefined,
  combinations: undefined,
  filters: undefined,
  translate: undefined,
  */
}, _temp);
exports.default = LocaleProvider;
//# sourceMappingURL=LocaleProvider.js.map