'use strict';

exports.__esModule = true;
exports.NamespaceContext = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NamespaceContext = exports.NamespaceContext = (0, _react.createContext)({});

var Namespace = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(Namespace, _Component);

  function Namespace() {
    (0, _classCallCheck3.default)(this, Namespace);
    return (0, _possibleConstructorReturn3.default)(this, _Component.apply(this, arguments));
  }

  Namespace.prototype.getPath = function getPath() {
    var _props = this.props,
        path = _props.path,
        compose = _props.compose,
        namespace = _props.namespace;

    if (!compose || !path) {
      return path;
    }

    if (namespace) {
      var parentPath = namespace.getPath();
      if (parentPath) {
        return parentPath + '.' + path;
      }
    }

    return path;
  };

  Namespace.prototype.render = function render() {
    var children = this.props.children;


    return _react2.default.createElement(
      NamespaceContext.Provider,
      { value: { namespace: this } },
      children
    );
  };

  return Namespace;
}(_react.Component), _class.defaultProps = {
  path: undefined,
  compose: undefined,
  namespace: undefined
}, _temp);
exports.default = (0, _react.forwardRef)(function (props, ref) {
  return _react2.default.createElement(
    NamespaceContext.Consumer,
    null,
    function (_ref) {
      var namespace = _ref.namespace;
      return _react2.default.createElement(Namespace, (0, _extends3.default)({}, props, {
        namespace: namespace,
        ref: ref
      }));
    }
  );
});
//# sourceMappingURL=Namespace.js.map