'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp2, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LocaleProvider = require('./LocaleProvider');

var _Namespace = require('./Namespace');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ProvideTranslate = (_temp2 = _class = function (_Component) {
  (0, _inherits3.default)(ProvideTranslate, _Component);

  function ProvideTranslate() {
    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ProvideTranslate);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, _Component.call.apply(_Component, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  ProvideTranslate.prototype.getPath = function getPath(path) {
    var _props = this.props,
        namespace = _props.namespace,
        ignoreNamespace = _props.ignoreNamespace;

    if (!namespace || ignoreNamespace) {
      return path;
    }

    var parentPath = namespace.getPath();
    if (!parentPath) {
      return path;
    }

    return parentPath + '.' + path;
  };

  ProvideTranslate.prototype.render = function render() {
    var children = this.props.children;


    return children(this.translate);
  };

  return ProvideTranslate;
}(_react.Component), _class.defaultProps = {
  ignoreNamespace: false
}, _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.translate = function (path) {
    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    var localeProvider = _this2.props.localeProvider;


    return localeProvider.get.apply(localeProvider, [_this2.getPath(path)].concat(args));
  };
}, _temp2);
exports.default = (0, _react.forwardRef)(function (props, ref) {
  return _react2.default.createElement(
    _LocaleProvider.LocaleProviderContext.Consumer,
    null,
    function (_ref) {
      var localeProvider = _ref.localeProvider;
      return _react2.default.createElement(
        _Namespace.NamespaceContext.Consumer,
        null,
        function (_ref2) {
          var namespace = _ref2.namespace;
          return _react2.default.createElement(ProvideTranslate, (0, _extends3.default)({}, props, {
            localeProvider: localeProvider,
            namespace: namespace,
            ref: ref
          }));
        }
      );
    }
  );
});
//# sourceMappingURL=ProvideTranslate.js.map