'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _class, _temp;

exports.prepareParams = prepareParams;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _LocaleProvider = require('./LocaleProvider');

var _LocaleProvider2 = _interopRequireDefault(_LocaleProvider);

var _Namespace = require('./Namespace');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function prepareParams(params, localeProvider) {
  var newParams = {};
  var changed = false;

  Object.keys(params).forEach(function (key) {
    var value = params[key];
    var isReactElement = (0, _react.isValidElement)(value);
    if (!isReactElement) {
      newParams[key] = value;
    } else {
      changed = true;

      var _localeProvider$props = localeProvider.props,
          _children = _localeProvider$props.children,
          locale = _localeProvider$props.locale,
          rest = (0, _objectWithoutProperties3.default)(_localeProvider$props, ['children', 'locale']);


      newParams[key] = (0, _server.renderToStaticMarkup)(_react2.default.createElement(
        _LocaleProvider2.default,
        rest,
        value
      ));
    }
  });

  return changed ? newParams : params;
}

var Translate = (_temp = _class = function (_Component) {
  (0, _inherits3.default)(Translate, _Component);

  function Translate() {
    (0, _classCallCheck3.default)(this, Translate);
    return (0, _possibleConstructorReturn3.default)(this, _Component.apply(this, arguments));
  }

  Translate.prototype.getPath = function getPath() {
    var _props = this.props,
        path = _props.path,
        $namespace = _props.$namespace;

    if (!$namespace) {
      return path;
    }

    var parentPath = $namespace.getPath();
    if (!parentPath) {
      return path;
    }

    return parentPath + '.' + path;
  };

  Translate.prototype.render = function render() {
    var _props2 = this.props,
        path = _props2.path,
        $namespace = _props2.$namespace,
        $localeProvider = _props2.$localeProvider,
        defaultValue = _props2.defaultValue,
        params = _props2.params,
        children = _props2.children,
        html = _props2.html,
        rest = (0, _objectWithoutProperties3.default)(_props2, ['path', '$namespace', '$localeProvider', 'defaultValue', 'params', 'children', 'html']);


    var updatedDefaultValue = !defaultValue && typeof children !== 'function' ? children : defaultValue;

    var updatedParams = prepareParams(params || rest, $localeProvider);
    var text = $localeProvider.get(this.getPath(), updatedParams, updatedDefaultValue);

    if (typeof children === 'function') {
      return children(text);
    }

    if (html) {
      return _react2.default.createElement('span', {
        dangerouslySetInnerHTML: {
          __html: text
        }
      });
    }

    return text;
  };

  return Translate;
}(_react.Component), _class.defaultProps = {
  defaultValue: undefined,
  description: undefined,
  params: undefined,
  children: undefined,
  $namespace: undefined,
  html: false
}, _temp);
exports.default = (0, _react.forwardRef)(function (props, ref) {
  return _react2.default.createElement(
    _LocaleProvider.LocaleProviderContext.Consumer,
    null,
    function (_ref) {
      var localeProvider = _ref.localeProvider;
      return _react2.default.createElement(
        _Namespace.NamespaceContext.Consumer,
        null,
        function (_ref2) {
          var namespace = _ref2.namespace;
          return _react2.default.createElement(Translate, (0, _extends3.default)({}, props, {
            $localeProvider: localeProvider,
            $namespace: namespace,
            ref: ref
          }));
        }
      );
    }
  );
});
//# sourceMappingURL=Translate.js.map