import _extends from 'babel-runtime/helpers/extends';
import _asyncToGenerator from 'babel-runtime/helpers/asyncToGenerator';
import React, { forwardRef, Component } from 'react';
import { LocaleProviderContext } from './LocaleProvider';

class LocaleSwitch extends Component {
  constructor(...args) {
    var _temp, _this;

    return _temp = _this = super(...args), this.handleChange = (() => {
      var _ref = _asyncToGenerator(function* (locale) {
        const { onError, onChange, localeProvider } = _this.props;

        try {
          yield localeProvider.setLocale(locale);
          if (onChange) {
            onChange(locale);
          }
        } catch (e) {
          if (onError) {
            onError(e);
          }
        }
      });

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    })(), _temp;
  }

  render() {
    const { children, localeProvider } = this.props;

    return children({
      locale: localeProvider.getLocale(),
      changeLocale: this.handleChange
    });
  }
}

LocaleSwitch.defaultProps = {
  onError: undefined,
  onChange: undefined
};
export default forwardRef((props, ref) => React.createElement(
  LocaleProviderContext.Consumer,
  null,
  ({ localeProvider }) => React.createElement(LocaleSwitch, _extends({}, props, {
    localeProvider: localeProvider,
    ref: ref
  }))
));
//# sourceMappingURL=LocaleSwitch.js.map