import _extends from 'babel-runtime/helpers/extends';
import React, { forwardRef, createContext, Component } from 'react';

export const NamespaceContext = createContext({});

class Namespace extends Component {

  getPath() {
    const { path, compose, namespace } = this.props;
    if (!compose || !path) {
      return path;
    }

    if (namespace) {
      const parentPath = namespace.getPath();
      if (parentPath) {
        return `${parentPath}.${path}`;
      }
    }

    return path;
  }

  render() {
    const { children } = this.props;

    return React.createElement(
      NamespaceContext.Provider,
      { value: { namespace: this } },
      children
    );
  }
}

Namespace.defaultProps = {
  path: undefined,
  compose: undefined,
  namespace: undefined
};
export default forwardRef((props, ref) => React.createElement(
  NamespaceContext.Consumer,
  null,
  ({ namespace }) => React.createElement(Namespace, _extends({}, props, {
    namespace: namespace,
    ref: ref
  }))
));
//# sourceMappingURL=Namespace.js.map