import _extends from 'babel-runtime/helpers/extends';
import React, { forwardRef, Component } from 'react';
import { LocaleProviderContext } from './LocaleProvider';
import { NamespaceContext } from './Namespace';

class ProvideTranslate extends Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), _initialiseProps.call(this), _temp;
  }

  getPath(path) {
    const { namespace, ignoreNamespace } = this.props;
    if (!namespace || ignoreNamespace) {
      return path;
    }

    const parentPath = namespace.getPath();
    if (!parentPath) {
      return path;
    }

    return `${parentPath}.${path}`;
  }

  render() {
    const { children } = this.props;

    return children(this.translate);
  }
}

ProvideTranslate.defaultProps = {
  ignoreNamespace: false
};

var _initialiseProps = function () {
  this.translate = (path, ...args) => {
    const { localeProvider } = this.props;

    return localeProvider.get(this.getPath(path), ...args);
  };
};

export default forwardRef((props, ref) => React.createElement(
  LocaleProviderContext.Consumer,
  null,
  ({ localeProvider }) => React.createElement(
    NamespaceContext.Consumer,
    null,
    ({ namespace }) => React.createElement(ProvideTranslate, _extends({}, props, {
      localeProvider: localeProvider,
      namespace: namespace,
      ref: ref
    }))
  )
));
//# sourceMappingURL=ProvideTranslate.js.map